/*
 * Copyright (C) 2005-2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.imode;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import jp.sourceforge.livez.dao.ImodeDecomail;

/**
 * Decomail を実装したクラスです。
 * 
 * @author 杉澤 浩二
 */
final class DecomailImpl implements Decomail {

	private static final long serialVersionUID = 1L;

	/**
	 * コンストラクタです。
	 * 
	 * @param decomail デコメール情報
	 */
	public DecomailImpl(final ImodeDecomail decomail) {
		this.version = decomail.getVersion();
		this.template = decomail.isTemplate();
	}

	/**
	 * デコメール対応バージョンを保持します。
	 */
	private float version;

	/*
	 * @see jp.sourceforge.livez.imode.Decomail#getVersion()
	 */
	public float getVersion() {
		return version;
	}

	/**
	 * テンプレート対応状況を保持します。
	 */
	private boolean template;

	/*
	 * @see jp.sourceforge.livez.imode.Decomail#isTemplate()
	 */
	public boolean isTemplate() {
		return template;
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public boolean equals(final Object obj) {
		return EqualsBuilder.reflectionEquals(this, obj);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}

}
